2 # Print a version string.
3 scriptversion
=2012-03-18.17
; # UTC
5 # Copyright (C) 2007-2012 Free Software Foundation, Inc.
7 # This program is free software: you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License as published by
9 # the Free Software Foundation; either version 3 of the License, or
10 # (at your option) any later version.
12 # This program is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 # GNU General Public License for more details.
17 # You should have received a copy of the GNU General Public License
18 # along with this program. If not, see <http://www.gnu.org/licenses/>.
20 # This script is derived from GIT-VERSION-GEN from GIT: http://git.or.cz/.
21 # It may be run two ways:
22 # - from a git repository in which the "git describe" command below
23 # produces useful output (thus requiring at least one signed tag)
24 # - from a non-git-repo directory containing a .tarball-version file, which
25 # presumes this script is invoked like "./git-version-gen .tarball-version".
27 # In order to use intra-version strings in your project, you will need two
28 # separate generated version string files:
30 # .tarball-version - present only in a distribution tarball, and not in
31 # a checked-out repository. Created with contents that were learned at
32 # the last time autoconf was run, and used by git-version-gen. Must not
33 # be present in either $(srcdir) or $(builddir) for git-version-gen to
34 # give accurate answers during normal development with a checked out tree,
35 # but must be present in a tarball when there is no version control system.
36 # Therefore, it cannot be used in any dependencies. GNUmakefile has
37 # hooks to force a reconfigure at distribution time to get the value
38 # correct, without penalizing normal development with extra reconfigures.
40 # .version - present in a checked-out repository and in a distribution
41 # tarball. Usable in dependencies, particularly for files that don't
42 # want to depend on config.h but do want to track version changes.
43 # Delete this file prior to any autoconf run where you want to rebuild
44 # files to pick up a version string change; and leave it stale to
45 # minimize rebuild time after unrelated changes to configure sources.
47 # As with any generated file in a VC'd directory, you should add
48 # /.version to .gitignore, so that you don't accidentally commit it.
49 # .tarball-version is never generated in a VC'd directory, so needn't
52 # Use the following line in your configure.ac, so that $(VERSION) will
53 # automatically be up-to-date each time configure is run (and note that
54 # since configure.ac no longer includes a version string, Makefile rules
55 # should not depend on configure.ac for version updates).
57 # AC_INIT([GNU project],
58 # m4_esyscmd([build-aux/git-version-gen .tarball-version]),
59 # [bug-project@example])
61 # Then use the following lines in your Makefile.am, so that .version
62 # will be present for dependencies, and so that .version and
63 # .tarball-version will exist in distribution tarballs.
65 # EXTRA_DIST = $(top_srcdir)/.version
66 # BUILT_SOURCES = $(top_srcdir)/.version
67 # $(top_srcdir)/.version:
68 # echo $(VERSION) > $@-t && mv $@-t $@
70 # echo $(VERSION) > $(distdir)/.tarball-version
75 version
="git-version-gen $scriptversion
77 Copyright 2011 Free Software Foundation, Inc.
78 There is NO warranty. You may redistribute this software
79 under the terms of the GNU General Public License.
80 For more information about these matters, see the files named COPYING."
83 Usage: $me [OPTION]... \$srcdir/.tarball-version [TAG-NORMALIZATION-SED-SCRIPT]
84 Print a version string.
88 --prefix prefix of git tags (default 'v')
90 --help display this help and exit
91 --version output version information and exit
93 Running without arguments will suffice in most cases."
97 while test $# -gt 0; do
99 --help) echo "$usage"; exit 0;;
100 --version) echo "$version"; exit 0;;
101 --prefix) shift; prefix
="$1";;
103 echo "$0: Unknown option '$1'." >&2
104 echo "$0: Try '--help' for more information." >&2
107 if test -z "$tarball_version_file"; then
108 tarball_version_file
="$1"
109 elif test -z "$tag_sed_script"; then
112 echo "$0: extra non-option argument '$1'." >&2
119 if test -z "$tarball_version_file"; then
124 tag_sed_script
="${tag_sed_script:-s/x/x/}"
129 # Avoid meddling by environment variable of the same name.
133 # First see if there is a tarball-only version file.
134 # then try "git describe", then default.
135 if test -f $tarball_version_file
137 v
=`cat $tarball_version_file` || v
=
139 *$nl*) v
= ;; # reject multi-line output
144 && echo "$0: WARNING: $tarball_version_file is missing or damaged" 1>&2
150 # Otherwise, if there is at least one git commit involving the working
151 # directory, and "git describe" output looks sensible, use that to
152 # derive a version string.
153 elif test "`git log -1 --pretty=format:x . 2>&1`" = x \
154 && v
=`git describe --abbrev=4 --match="$prefix*" HEAD 2>/dev/null \
155 || git describe --abbrev=4 HEAD 2>/dev/null` \
156 && v
=`printf '%s\n' "$v" | sed "$tag_sed_script"` \
162 # Is this a new git that lists number of commits since the last
163 # tag or the previous older version that did not?
164 # Newer: v6.10-77-g0f8faeb
165 # Older: v6.10-g0f8faeb
167 *-*-*) : git describe is okay three part flavor
;;
169 : git describe is older two part flavor
170 # Recreate the number of commits and rewrite such that the
171 # result is the same as if we were using the newer version
173 vtag
=`echo "$v" | sed 's/-.*//'`
174 commit_list
=`git rev-list "$vtag"..HEAD 2>/dev/null` \
175 ||
{ commit_list
=failed
;
176 echo "$0: WARNING: git rev-list failed" 1>&2; }
177 numcommits
=`echo "$commit_list" | wc -l`
178 v
=`echo "$v" | sed "s/\(.*\)-\(.*\)/\1-$numcommits-\2/"`;
179 test "$commit_list" = failed
&& v
=UNKNOWN
183 # Change the first '-' to a '.', so version-comparing tools work properly.
184 # Remove the "g" in git describe's output string, to save a byte.
185 v
=`echo "$v" | sed 's/-/./;s/\(.*\)-g/\1-/'`;
191 v
=`echo "$v" |sed "s/^$prefix//"`
193 # Test whether to append the "-dirty" suffix only if the version
194 # string we're using came from git. I.e., skip the test if it's "UNKNOWN"
195 # or if it came from .tarball-version.
196 if test -n "$v_from_git"; then
197 # Don't declare a version "dirty" merely because a time stamp has changed.
198 git update-index
--refresh > /dev
/null
2>&1
200 dirty
=`exec 2>/dev/null;git diff-index --name-only HEAD` || dirty
=
203 *) # Append the suffix only if there isn't one already.
211 # Omit the trailing newline, so that m4_esyscmd can use the result directly.
212 echo "$v" |
tr -d "$nl"
215 # eval: (add-hook 'write-file-hooks 'time-stamp)
216 # time-stamp-start: "scriptversion="
217 # time-stamp-format: "%:y-%02m-%02d.%02H"
218 # time-stamp-time-zone: "UTC"
219 # time-stamp-end: "; # UTC"